# include <allegro.h>

# define MAX_X 320
# define MAX_Y 240
# define VMODE GFX_AUTODETECT

BITMAP *buffer;
BITMAP *fundo;
BITMAP *img;
int x, y;

void mover(int d){
	switch (d){
		case 0: if (x > 0) x--; break;
		case 1: if (x < MAX_X - img->w) x++; break;
		case 2: if (y > 0) y--; break;
		case 3: if (y < MAX_Y -img->h) y++; break;
	}
	clear (buffer);
	draw_sprite(buffer, fundo, 0, 0);
	draw_sprite(buffer, img, x, y);
	blit(buffer, screen, 0, 0, 0, 0, MAX_X, MAX_Y);
}       

int main (){
	allegro_init();
	install_keyboard();
	set_color_depth(16);
	set_gfx_mode(VMODE, MAX_X, MAX_Y, 0, 0);
	buffer = create_bitmap(MAX_X, MAX_Y);

	fundo = load_bitmap("fundo.bmp", NULL);
	img = load_bitmap("avatar.bmp", NULL);
	x=0; y=0;

	draw_sprite(buffer, fundo, 0, 0);
	draw_sprite(buffer, img, x, y);
	blit(buffer, screen, 0, 0, 0, 0, MAX_X, MAX_Y);

	while (!key[KEY_ESC]){
		if(key[KEY_LEFT]) mover(0);
		else if (key[KEY_RIGHT]) mover (1);
		else if (key[KEY_UP]) mover (2);
		else if (key[KEY_DOWN]) mover (3);
	}
	destroy_bitmap(img);
	destroy_bitmap(fundo);
	destroy_bitmap(buffer);
	allegro_exit();
	return 0;
}
END_OF_MAIN();
