#include <allegro.h>

#define MAX_X 320
#define MAX_Y 240
#define VMODE GFX_AUTODETECT
#define TEMPO_LIMITE 1

BITMAP *buffer;
BITMAP *fundo;
BITMAP *img;
BITMAP *img2;
int x, y, x2, y2, tempo;

int colisao(BITMAP* imgA, BITMAP* imgB) {   
     if ((x+imgA->w > x2) && (x < x2+imgB->h) &&
         (y+imgA->h > y2) && (y < y2+imgB->h)){
        return 1;
     }
     return 0;
}

void desenhar() {
	clear (buffer);
	draw_sprite(buffer, fundo, 0, 0);
	draw_sprite(buffer, img, x, y);
	draw_sprite(buffer, img2, x2, y2);
	blit(buffer, screen, 0, 0, 0, 0, MAX_X, MAX_Y);
}

void mover(int d){
	switch (d){
		case 0: if (x > 0) x--; break;
		case 1: if (x < MAX_X - img->w) x++; break;
		case 2: if (y > 0) y--; break;
		case 3: if (y < MAX_Y -img->h) y++; break;
	}
}

void mover_img2() {
     tempo++;
     if (tempo > TEMPO_LIMITE){
        if (!colisao(img, img2)) {
            if (x > x2) x2++; else x2--;        
            if (y > y2) y2++; else y2--;
        }
        tempo = 0;
     }
}

int main (){
	allegro_init();
	install_keyboard();
	set_color_depth(16);
	set_gfx_mode(VMODE, MAX_X, MAX_Y, 0, 0);
	buffer = create_bitmap(MAX_X, MAX_Y);

	fundo = load_bitmap("fundo.bmp", NULL);
	img = load_bitmap("avatar.bmp", NULL);
	img2 = load_bitmap("avatar.bmp", NULL);
	x=0; y=0;
	x2 = (int) (MAX_X / 2) - (img2->w / 2);
	y2 = (int) (MAX_Y / 2) - (img2->h / 2);
	tempo = 0;

	while (!key[KEY_ESC]){
		if(key[KEY_LEFT]) mover(0);
		else if (key[KEY_RIGHT]) mover (1);
		else if (key[KEY_UP]) mover (2);
		else if (key[KEY_DOWN]) mover (3);
		mover_img2();
		desenhar();
	}
	destroy_bitmap(img);
	destroy_bitmap(img2);
	destroy_bitmap(fundo);
	destroy_bitmap(buffer);
	allegro_exit();
	return 0;
}
END_OF_MAIN();
