#include <allegro.h>

#define MAX_X 320
#define MAX_Y 240
#define VMODE GFX_AUTODETECT//_WINDOWED
#define SOUND_CARD DIGI_AUTODETECT
#define MIDI_CARD MIDI_AUTODETECT
#define TEMPO_LIMITE 1

BITMAP *buffer;
BITMAP *fundo;
BITMAP *avatar;
BITMAP *img0;
BITMAP *img1;
MIDI *musica;
SAMPLE *som;
volatile int tempo;
int fx, fy;
int x, y;
int i;

void aumenta_tempo(void) {
	tempo++;
}
END_OF_FUNCTION(aumenta_tempo);

void desenhar() {
	clear(buffer);
	blit(fundo, buffer, fx, fy, 0, 0, MAX_X+fx, MAX_Y+fy);
	draw_sprite(buffer, avatar, (int) (MAX_X / 2) - (avatar->w / 2), 160);
	blit(buffer, screen, 0, 0, 0, 0, MAX_X, MAX_Y);
}

void mover(int d){
	switch (d){
	case 0:
		if (fx > 0) fx--;
		else play_sample(som, 255, 128, 1000, FALSE);
		break;
	case 1:
		if (fundo->w  > MAX_X + fx) fx++;
		else play_sample(som, 255, 128, 1000, FALSE);
		break;
	case 2:
		if (fy > 0) fy--;
		break;
	case 3:
		if (fundo->h  > MAX_Y + fy) fy++;
		break;
	}
}

int main (){
	allegro_init();
	install_keyboard();
	install_timer();	
	set_color_depth(16);
	set_gfx_mode(VMODE, MAX_X, MAX_Y, 0, 0);	
	install_sound(SOUND_CARD, MIDI_CARD, NULL);
	set_volume(128, 255);

	buffer = create_bitmap(MAX_X, MAX_Y);
	fundo = load_bitmap("floresta.bmp", NULL);
	img0 = load_bitmap("freebsd0.bmp", NULL);
	img1 = load_bitmap("freebsd1.bmp", NULL);
	avatar = img0;
	musica = load_midi("vampweird.mid");
	som = load_sample("som.wav");

	tempo = 0;
	LOCK_VARIABLE(tempo);
	LOCK_FUNCTION(aumenta_tempo);
	install_int(aumenta_tempo, 1000);
	
	play_midi(musica, TRUE);

	fx=0; fy=0;
	while (!key[KEY_ESC]){
		if(key[KEY_LEFT]) {
			avatar = img1;
			mover(0);
		} else if (key[KEY_RIGHT]) {
			avatar = img0;
			mover (1);
		} else if (key[KEY_UP]) mover (2);
		else if (key[KEY_DOWN]) mover (3);
		desenhar();
	}

	stop_midi();
	remove_sound();
	destroy_bitmap(fundo);
	destroy_bitmap(buffer);
	remove_int(aumenta_tempo);
	remove_timer();
	fade_out(4);
	allegro_exit();
	return 0;
}
END_OF_MAIN();
