#include <allegro.h>

#define MAX_X 320
#define MAX_Y 240
#define VMODE GFX_AUTODETECT//_WINDOWED
#define TEMPO_LIMITE 1

BITMAP *buffer;
BITMAP *fundo;
BITMAP *avatar;
BITMAP *img0;
BITMAP *img1;
int fx, fy;
int x, y;
int i;

void desenhar() {
	clear(buffer);
	blit(fundo, buffer, fx, fy, 0, 0, MAX_X+fx, MAX_Y+fy);
	draw_sprite(buffer, avatar,
		(int) (MAX_X / 2) - (avatar->w / 2),
		(int) (MAX_Y / 2) - (avatar->h / 2));
	blit(buffer, screen, 0, 0, 0, 0, MAX_X, MAX_Y);
}

void mover(int d){
	switch (d){
		case 0: if (fx > 0) fx--; break;
		case 1: if (fundo->w  > MAX_X + fx) fx++; break;
		case 2: if (fy > 0) fy--; break;
		case 3: if (fundo->h  > MAX_Y + fy) fy++; break;
	}
}

int main (){
	allegro_init();
	install_keyboard();
	set_color_depth(16);
	set_gfx_mode(VMODE, MAX_X, MAX_Y, 0, 0);

	buffer = create_bitmap(MAX_X, MAX_Y);
	fundo = load_bitmap("mapbig.bmp", NULL);
	img0 = load_bitmap("freebsd0.bmp", NULL);
	img1 = load_bitmap("freebsd1.bmp", NULL);
	avatar = img0;

	fx=0; fy=0;
	while (!key[KEY_ESC]){
		if(key[KEY_LEFT]) {
			avatar = img1;
			mover(0);
		} else if (key[KEY_RIGHT]) {
			avatar = img0;
			mover (1);
		} else if (key[KEY_UP]) mover (2);
		else if (key[KEY_DOWN]) mover (3);
		desenhar();
	}
	destroy_bitmap(fundo);
	destroy_bitmap(buffer);
	allegro_exit();
	return 0;
}
END_OF_MAIN();
